
int wejscieUV = A0; //wyjscie z sensora

void setup()
{
  pinMode(wejscieUV, INPUT);
  Serial.begin(9600);
}

void loop()
{
  int poziomUV = averageAnalogRead(wejscieUV); //uśredniony odczyt z wyjscia czujnika

  float napiecieWejsciowe = 5.0 * poziomUV/1024; //obliczenie napiecia na wyjsciu czujnika UV
  
  float natezenieUV = mapfloat(napiecieWejsciowe, 0.99, 2.9, 0.0, 15.0); //obliczenie zmierzonego natezenia swiatla UV

  Serial.print("Natezenie swiatla UV: ");
  Serial.print(natezenieUV);
  Serial.print(" mW/cm^2");

  Serial.println();
  delay(400);
}


//Uśrenienie odczytów z portu analogowego
int averageAnalogRead(int pinToRead)
{
  byte numberOfReadings = 10;
  unsigned int runningValue = 0;

  for(int x = 0 ; x < numberOfReadings ; x++)
    runningValue += analogRead(pinToRead);
  runningValue /= numberOfReadings;

  return(runningValue);

}


//Liniowe mapowanie wartosci (napiecia na natezenie UV)
//Kopia funkcji map() dla zmiennych typu float
//Źródło: http://forum.arduino.cc/index.php?topic=3922.0
float mapfloat(float x, float in_min, float in_max, float out_min, float out_max)
{
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}
